/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh7780.h 1596 2009-06-29 09:41:45Z ertl-honda $
 */

/*
 *  SH7780Υϡɥ񸻤
 */

#ifndef TOPPERS_SH7780_H
#define TOPPERS_SH7780_H

#include <sil.h>

/*
 *  㳰٥ȥ쥸
 */
#define TRA         0xff000020
#define EXPEVT      0xff000024
#define INTEVT      0xff000028

/*
 *   ХơȥȥϢ
 */
#define RFCR        0xff800028   /* H */

#define RFCR_CLEAR  0xa400

/*
 *  ߤˤä INTEVT 쥸ꤵ
 */
#define TMU0_INTEVT         UINT_C(0x580)
#define SCIF0_RXI_INTEVT    UINT_C(0x720)
#define SCIF0_TXI_INTEVT    UINT_C(0x760)
#define SCIF0_BRI_INTEVT    UINT_C(0x740)
#define SCIF1_RXI_INTEVT    UINT_C(0xBA0)
#define SCIF1_TXI_INTEVT    UINT_C(0xBE0)
#define SCIF1_BRI_INTEVT    UINT_C(0xBC0)

/*
 *  IRCϢΥ쥸
 */
#define ICR0     UINT_C(0x1FD00000) /* W */
#define ICR1     UINT_C(0x1FD0001C) /* W */
#define INT2PRI0 UINT_C(0xFFD40000) /* W */
#define INT2PRI1 UINT_C(0xFFD40004) /* W */
#define INT2PRI2 UINT_C(0xFFD40008) /* W */
#define INT2PRI3 UINT_C(0xFFD4000C) /* W */
#define INT2PRI4 UINT_C(0xFFD40010) /* W */
#define INT2PRI5 UINT_C(0xFFD40014) /* W */
#define INT2PRI6 UINT_C(0xFFD40018) /* W */
#define INT2PRI7 UINT_C(0xFFD4001C) /* W */

#define INT2MSKR  UINT_C(0xFFD40038)
#define INT2MSKCR UINT_C(0xFFD4003C)

#define IRQ_LOWLEVEL    UINT_C(0x02)
#define IRQ_POSEDGE     UINT_C(0x01)
#define IRQ_NEGEDGE     UINT_C(0x00)

/*
 * ޡ쥸
 */
#define TMU_TOCR   UINT_C(0xffd80000)  /* B */
#define TMU_TSTR   UINT_C(0xffd80004)  /* B */
#define TMU_TCOR0  UINT_C(0xffd80008)  /* W */
#define TMU_TCNT0  UINT_C(0xffd8000c)  /* W */
#define TMU_TCR0   UINT_C(0xffd80010)  /* H */
#define TMU_TCOR1  UINT_C(0xffd80014)  /* W */
#define TMU_TCNT1  UINT_C(0xffd80018)  /* W */
#define TMU_TCR1   UINT_C(0xffd8001c)  /* H */
#define TMU_TCOR2  UINT_C(0xffd80020)  /* W */
#define TMU_TCNT2  UINT_C(0xffd80024)  /* W */
#define TMU_TCR2   UINT_C(0xffd80028)  /* H */

#define TMU_STR0   UINT_C(0x01)
#define TMU_STR1   UINT_C(0x02)
#define TMU_STR2   UINT_C(0x04)
#define TCR_UNF    UINT_C(0x0100)    

/*
 *  FIFOդꥢ륳ߥ˥󥤥󥿡ե(SCIF)쥸
 */
#define SH_SCIF0_BASE UINT_C(0xFFE00000)
#define SH_SCIF1_BASE UINT_C(0xFFE10000)

/*
 *  GPIOϢ쥸
 */
#define GPIO_PHCP UINT_C(0xFFEA000E) /* H */
#define GPIO_PHCP_SCIF0_ENABLE (~UINT_C(0x007F))

/*
 *  å쥸
 */
#define CCR           UINT_C(0xff00001c)   /* W */
#define CCR_DISABLE   UINT_C(0x00000808)  /* å̵ */

/*
 *  ХơȥȥϢ
 */
#define LBSC_MMSELR UINT_C(0xff400020) /* W */
#define LBSC_CS0BCR UINT_C(0xff802000) /* W */
#define LBSC_CS0WCR UINT_C(0xff802008) /* W */

#endif /* TOPPERS_SH7780_H */
