/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.c 1597 2009-06-29 09:42:56Z ertl-honda $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СMS7727CP01ѡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "target_serial.h"

/*
 * ߵĥӥå
 */    
static const uint32_t pinter_val[TNUM_SIOP] = {
    PINTER_PINT7E,
#if TNUM_SIOP > 2
    PINTER_PINT6E,
#endif /* TNUM_SIOP > 2 */    
};  

/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
    st16c2550_initialize();    
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB    *p_siopcb;
    bool_t    opnflg;
    ER        ercd;

    /*
     *  ץ󤷤ݡȤ뤫opnflgɤǤ
     */
    opnflg = st16c2550_openflag();

    /*
     *  ǥХ¸Υץ
     */
    p_siopcb = st16c2550_opn_por(siopid, exinf);

    /*
     *  ꥢI/OߤΥޥ롥
     */
    if (!opnflg) {
        ercd = ena_int(INTNO_SIO);
        assert(ercd == E_OK);
        /* PINT֥͡ */
        sil_wrh_mem((void*)PINTER,(sil_reh_mem((void *)PINTER) | pinter_val[siopid-1]));
    }
    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
    ER        ercd;

    /*
     *  ǥХ¸Υ
     */
    st16c2550_cls_por(p_siopcb);

    /*
     *  ꥢI/Oߤޥ롥
     */
    if (!st16c2550_openflag()) {
        ercd = dis_int(INTNO_SIO);
        assert(ercd == E_OK);
    }
}

/*
 *  SIOγߥӥ롼
 */
void
sio_isr(intptr_t exinf)
{
    st16c2550_isr();
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
    return(st16c2550_snd_chr(siopcb, c));
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
    return(st16c2550_rcv_chr(siopcb));
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    st16c2550_ena_cbr(siopcb, cbrtn);
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    st16c2550_dis_cbr(siopcb, cbrtn);
}

/*
 *  ꥢI/OݡȤǽХå
 */
void
st16c2550_irdy_snd(intptr_t exinf)
{
    sio_irdy_snd(exinf);
}

/*
 *  ꥢI/OݡȤμΥХå
 */
void
st16c2550_irdy_rcv(intptr_t exinf)
{
    sio_irdy_rcv(exinf);
}
